/* bidiriterator.c generated by valac 0.56.17, the Vala compiler
 * generated from bidiriterator.vala, do not modify */

/* bidiriterator.vala
 *
 * Copyright (C) 2009  Didier Villevalois, Maciej Piechotka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Maciej Piechotka <uzytkownik2@gmail.com>
 */

#include "gee.h"
#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static GType gee_bidir_iterator_get_type_once (void);

/**
 * Rewinds to the previous element in the iteration.
 *
 * @return ``true`` if the iterator has a previous element
 */
gboolean
gee_bidir_iterator_previous (GeeBidirIterator* self)
{
	GeeBidirIteratorIface* _iface_;
#line 33 "bidiriterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "bidiriterator.vala"
	_iface_ = GEE_BIDIR_ITERATOR_GET_INTERFACE (self);
#line 33 "bidiriterator.vala"
	if (_iface_->previous) {
#line 33 "bidiriterator.vala"
		return _iface_->previous (self);
#line 59 "bidiriterator.c"
	}
#line 33 "bidiriterator.vala"
	return FALSE;
#line 63 "bidiriterator.c"
}

/**
 * Checks whether there is a previous element in the iteration.
 *
 * @return ``true`` if the iterator has a previous element
 */
gboolean
gee_bidir_iterator_has_previous (GeeBidirIterator* self)
{
	GeeBidirIteratorIface* _iface_;
#line 40 "bidiriterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "bidiriterator.vala"
	_iface_ = GEE_BIDIR_ITERATOR_GET_INTERFACE (self);
#line 40 "bidiriterator.vala"
	if (_iface_->has_previous) {
#line 40 "bidiriterator.vala"
		return _iface_->has_previous (self);
#line 83 "bidiriterator.c"
	}
#line 40 "bidiriterator.vala"
	return FALSE;
#line 87 "bidiriterator.c"
}

/**
 * Rewinds to the first element in the iteration.
 *
 * @return ``true`` if the iterator has a first element
 */
gboolean
gee_bidir_iterator_first (GeeBidirIterator* self)
{
	GeeBidirIteratorIface* _iface_;
#line 47 "bidiriterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "bidiriterator.vala"
	_iface_ = GEE_BIDIR_ITERATOR_GET_INTERFACE (self);
#line 47 "bidiriterator.vala"
	if (_iface_->first) {
#line 47 "bidiriterator.vala"
		return _iface_->first (self);
#line 107 "bidiriterator.c"
	}
#line 47 "bidiriterator.vala"
	return FALSE;
#line 111 "bidiriterator.c"
}

/**
 * Advances to the last element in the iteration.
 *
 * @return ``true`` if the iterator has a last element
 */
gboolean
gee_bidir_iterator_last (GeeBidirIterator* self)
{
	GeeBidirIteratorIface* _iface_;
#line 54 "bidiriterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "bidiriterator.vala"
	_iface_ = GEE_BIDIR_ITERATOR_GET_INTERFACE (self);
#line 54 "bidiriterator.vala"
	if (_iface_->last) {
#line 54 "bidiriterator.vala"
		return _iface_->last (self);
#line 131 "bidiriterator.c"
	}
#line 54 "bidiriterator.vala"
	return FALSE;
#line 135 "bidiriterator.c"
}

static void
gee_bidir_iterator_default_init (GeeBidirIteratorIface * iface,
                                 gpointer iface_data)
{
}

/**
 * A bi-directional iterator.
 */
static GType
gee_bidir_iterator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GeeBidirIteratorIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gee_bidir_iterator_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gee_bidir_iterator_type_id;
	gee_bidir_iterator_type_id = g_type_register_static (G_TYPE_INTERFACE, "GeeBidirIterator", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gee_bidir_iterator_type_id, GEE_TYPE_ITERATOR);
	return gee_bidir_iterator_type_id;
}

GType
gee_bidir_iterator_get_type (void)
{
	static volatile gsize gee_bidir_iterator_type_id__once = 0;
	if (g_once_init_enter (&gee_bidir_iterator_type_id__once)) {
		GType gee_bidir_iterator_type_id;
		gee_bidir_iterator_type_id = gee_bidir_iterator_get_type_once ();
		g_once_init_leave (&gee_bidir_iterator_type_id__once, gee_bidir_iterator_type_id);
	}
	return gee_bidir_iterator_type_id__once;
}

